import { UserId } from '../../user/types';
import { z } from 'zod';
import { userBooksQueryParser } from './parsers';
import { BookType } from '../types';
export declare type UserBooksQuery = z.infer<typeof userBooksQueryParser>;
interface UserBooksReportRow {
    userId: UserId;
    books: {
        [t in BookType]: {
            sumFrom: bigint;
            sumTo: bigint;
        };
    };
}
export interface UserBooksReportResponse {
    rows: readonly UserBooksReportRow[];
    totals: UserBooksReportRow['books'];
    count: number;
}
declare type BookToJson<T extends {
    sumTo: bigint;
    sumFrom: bigint;
}> = Omit<T, 'sumTo' | 'sumFrom'> & {
    sumTo: string;
    sumFrom: string;
};
declare type BooksToJson<T extends {
    [k in BookType]: B;
}, B extends {
    sumTo: bigint;
    sumFrom: bigint;
} = T[BookType]> = {
    [k in BookType]: BookToJson<T[k]>;
};
export interface UserBooksReportResponseSerialized {
    rows: (Omit<UserBooksReportResponse['rows'][number], 'books'> & {
        books: BooksToJson<UserBooksReportResponse['rows'][number]['books']>;
    })[];
    totals: BooksToJson<UserBooksReportResponse['totals']>;
    count: UserBooksReportResponse['count'];
}
export {};
